/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
	"fmt"
)

// FlowOperationLeftJoin - struct for FlowOperationLeftJoin
type FlowOperationLeftJoin struct {
	FlowOperationLeftJoin *FlowOperationLeftJoin
}

// FlowOperationLeftJoinAsFlowOperationLeftJoin is a convenience function that returns FlowOperationLeftJoin wrapped in FlowOperationLeftJoin
func FlowOperationLeftJoinAsFlowOperationLeftJoin(v *FlowOperationLeftJoin) FlowOperationLeftJoin {
	return FlowOperationLeftJoin{
		FlowOperationLeftJoin: v,
	}
}

// Unmarshal JSON data into one of the pointers in the struct
func (dst *FlowOperationLeftJoin) UnmarshalJSON(data []byte) error {
	var err error
	// this object is nullable so check if the payload is null or empty string
	if string(data) == "" || string(data) == "{}" {
		return nil
	}

	match := 0
	// try to unmarshal data into FlowOperationLeftJoin
	err = newStrictDecoder(data).Decode(&dst.FlowOperationLeftJoin)
	if err == nil {
		jsonFlowOperationLeftJoin, _ := json.Marshal(dst.FlowOperationLeftJoin)
		if string(jsonFlowOperationLeftJoin) == "{}" { // empty struct
			dst.FlowOperationLeftJoin = nil
		} else {
			match++
		}
	} else {
		dst.FlowOperationLeftJoin = nil
	}

	if match > 1 { // more than 1 match
		// reset to nil
		dst.FlowOperationLeftJoin = nil

		return fmt.Errorf("data matches more than one schema in oneOf(FlowOperationLeftJoin)")
	} else if match == 1 {
		return nil // exactly one match
	} else { // no match
		return fmt.Errorf("data failed to match schemas in oneOf(FlowOperationLeftJoin)")
	}
}

// Marshal data from the first non-nil pointers in the struct to JSON
func (src FlowOperationLeftJoin) MarshalJSON() ([]byte, error) {
	if src.FlowOperationLeftJoin != nil {
		return json.Marshal(&src.FlowOperationLeftJoin)
	}

	return nil, nil // no data in oneOf schemas
}

// Get the actual instance
func (obj *FlowOperationLeftJoin) GetActualInstance() interface{} {
	if obj == nil {
		return nil
	}
	if obj.FlowOperationLeftJoin != nil {
		return obj.FlowOperationLeftJoin
	}

	// all schemas are nil
	return nil
}

type NullableFlowOperationLeftJoin struct {
	value *FlowOperationLeftJoin
	isSet bool
}

func (v NullableFlowOperationLeftJoin) Get() *FlowOperationLeftJoin {
	return v.value
}

func (v *NullableFlowOperationLeftJoin) Set(val *FlowOperationLeftJoin) {
	v.value = val
	v.isSet = true
}

func (v NullableFlowOperationLeftJoin) IsSet() bool {
	return v.isSet
}

func (v *NullableFlowOperationLeftJoin) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableFlowOperationLeftJoin(val *FlowOperationLeftJoin) *NullableFlowOperationLeftJoin {
	return &NullableFlowOperationLeftJoin{value: val, isSet: true}
}

func (v NullableFlowOperationLeftJoin) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableFlowOperationLeftJoin) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
